'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _estraverse = require('estraverse');

var _estraverse2 = _interopRequireDefault(_estraverse);

// import AssignmentPattern from '../syntax/assignment-pattern';

exports['default'] = function (ast) {
  _estraverse2['default'].replace(ast, {
    enter: findDefaultAssignments
  });
  _estraverse2['default'].replace(ast, {
    enter: removeExpressions
  });
};

var lastFunction = {};

function findDefaultAssignments(node) {
  if (node.type === 'FunctionDeclaration' || node.type === 'FunctionExpression') {
    lastFunction = node;
    lastFunction._args = node.params.map(function (arg) {
      return arg.name;
    });
    lastFunction.defaults = [];
  }

  if (node.type === 'ExpressionStatement') {
    node.expression._parent = node;
  }
  if (node.type === 'AssignmentExpression' && lastFunction._args && lastFunction._args.indexOf(node.left.name) > -1 && node.right.type === 'LogicalExpression' && node.right.operator === '||' && node.right.left.name === node.left.name) {

    var argIndex = lastFunction._args.indexOf(node.left.name);

    lastFunction.defaults[argIndex] = node.right.right;
    node._parent._remove = true;
  }
}

function removeExpressions(node) {
  if (node._remove) {
    return this.remove();
  }
}
module.exports = exports['default'];