'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _estraverse = require('estraverse');

var _estraverse2 = _interopRequireDefault(_estraverse);

exports['default'] = function (ast) {
  _estraverse2['default'].traverse(ast, {
    enter: replaceVar
  });
};

var declarations = {};

function replaceVar(node) {
  if (node.type === 'VariableDeclaration') {
    node.declarations.forEach(function (dec) {
      declarations[dec.id.name] = node;
      declarations[dec.id.name].kind = 'const';
    });
  }

  if (node.type === 'AssignmentExpression') {
    var left = node.left.name || node.left.property.name;

    if (declarations[left]) {
      declarations[left].kind = 'let';
    }
  } else if (node.type === 'UpdateExpression') {
    var _name = node.argument.name;
    if (declarations[_name]) {
      declarations[_name].kind = 'let';
    }
  }
}
module.exports = exports['default'];